Introduce LoadParser and Types for a new Collector
[ganeti-local] / Makefile.am
1 # Ganeti makefile
2 # - Indent with tabs only.
3 # - Keep files sorted; one line per file.
4 # - Directories in lib/ must have their own *dir variable (see hypervisor).
5 # - All directories must be listed DIRS.
6 # - Use autogen.sh to generate Makefile.in and configure script.
7
8 # Automake doesn't export these variables before version 1.10.
9 abs_top_builddir = @abs_top_builddir@
10 abs_top_srcdir = @abs_top_srcdir@
11
12 # Helper values for calling builtin functions
13 empty :=
14 space := $(empty) $(empty)
15 comma := ,
16
17 # Helper function to strip src/ and test/hs/ from a list
18 strip_hsroot = $(patsubst src/%,%,$(patsubst test/hs/%,%,$(1)))
19
20 # Use bash in order to be able to use pipefail
21 SHELL=/bin/bash
22
23 # Enable colors in shelltest
24 SHELLTESTARGS = "-c"
25
26 ACLOCAL_AMFLAGS = -I autotools
27 BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
28 RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
29 CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
30 CHECK_HEADER = $(top_srcdir)/autotools/check-header
31 CHECK_MAN_DASHES = $(top_srcdir)/autotools/check-man-dashes
32 CHECK_MAN_REFERENCES = $(top_srcdir)/autotools/check-man-references
33 CHECK_MAN_WARNINGS = $(top_srcdir)/autotools/check-man-warnings
34 CHECK_VERSION = $(top_srcdir)/autotools/check-version
35 CHECK_NEWS = $(top_srcdir)/autotools/check-news
36 CHECK_IMPORTS = $(top_srcdir)/autotools/check-imports
37 DOCPP = $(top_srcdir)/autotools/docpp
38 REPLACE_VARS_SED = autotools/replace_vars.sed
39 CONVERT_CONSTANTS = $(top_srcdir)/autotools/convert-constants
40 BUILD_RPC = $(top_srcdir)/autotools/build-rpc
41 SHELL_ENV_INIT = autotools/shell-env-init
42
43 # Note: these are automake-specific variables, and must be named after
44 # the directory + 'dir' suffix
45 clientdir = $(pkgpythondir)/client
46 cmdlibdir = $(pkgpythondir)/cmdlib
47 hypervisordir = $(pkgpythondir)/hypervisor
48 storagedir = $(pkgpythondir)/storage
49 httpdir = $(pkgpythondir)/http
50 masterddir = $(pkgpythondir)/masterd
51 confddir = $(pkgpythondir)/confd
52 rapidir = $(pkgpythondir)/rapi
53 serverdir = $(pkgpythondir)/server
54 watcherdir = $(pkgpythondir)/watcher
55 impexpddir = $(pkgpythondir)/impexpd
56 utilsdir = $(pkgpythondir)/utils
57 toolsdir = $(pkglibdir)/tools
58 iallocatorsdir = $(pkglibdir)/iallocators
59 pytoolsdir = $(pkgpythondir)/tools
60 docdir = $(datadir)/doc/$(PACKAGE)
61 myexeclibdir = $(pkglibdir)
62
63 # Delete output file if an error occurred while building it
64 .DELETE_ON_ERROR:
65
66 HS_DIRS = \
67         src \
68         src/Ganeti \
69         src/Ganeti/Confd \
70         src/Ganeti/Curl \
71         src/Ganeti/Cpu \
72         src/Ganeti/DataCollectors \
73         src/Ganeti/HTools \
74         src/Ganeti/HTools/Backend \
75         src/Ganeti/HTools/Program \
76         src/Ganeti/Hypervisor \
77         src/Ganeti/Hypervisor/Xen \
78         src/Ganeti/Monitoring \
79         src/Ganeti/Query \
80         src/Ganeti/Storage \
81         src/Ganeti/Storage/Diskstats \
82         src/Ganeti/Storage/Drbd \
83         src/Ganeti/Storage/Lvm \
84         test/hs \
85         test/hs/Test \
86         test/hs/Test/Ganeti \
87         test/hs/Test/Ganeti/Storage \
88         test/hs/Test/Ganeti/Storage/Diskstats \
89         test/hs/Test/Ganeti/Storage/Drbd \
90         test/hs/Test/Ganeti/Storage/Lvm \
91         test/hs/Test/Ganeti/Confd \
92         test/hs/Test/Ganeti/HTools \
93         test/hs/Test/Ganeti/HTools/Backend \
94         test/hs/Test/Ganeti/Hypervisor \
95         test/hs/Test/Ganeti/Hypervisor/Xen \
96         test/hs/Test/Ganeti/Query
97
98 # Haskell directories without the roots (src, test/hs)
99 HS_DIRS_NOROOT = $(filter-out src,$(filter-out test/hs,$(HS_DIRS)))
100
101 DIRS = \
102         $(HS_DIRS) \
103         autotools \
104         daemons \
105         devel \
106         devel/data \
107         doc \
108         doc/css \
109         doc/examples \
110         doc/examples/gnt-debug \
111         doc/examples/hooks \
112         test/data/htools \
113         test/data/htools/rapi \
114         test/hs/shelltests \
115         test/autotools \
116         lib \
117         lib/build \
118         lib/client \
119         lib/cmdlib \
120         lib/confd \
121         lib/http \
122         lib/hypervisor \
123         lib/impexpd \
124         lib/masterd \
125         lib/rapi \
126         lib/server \
127         lib/storage \
128         lib/tools \
129         lib/utils \
130         lib/watcher \
131         man \
132         qa \
133         test \
134         test/data \
135         test/data/bdev-rbd \
136         test/data/ovfdata \
137         test/data/ovfdata/other \
138         test/py \
139         tools
140
141 ALL_APIDOC_HS_DIRS = \
142         $(APIDOC_HS_DIR) \
143         $(patsubst %,$(APIDOC_HS_DIR)/%,$(call strip_hsroot,$(HS_DIRS_NOROOT)))
144
145 BUILDTIME_DIR_AUTOCREATE = \
146         scripts \
147         $(APIDOC_DIR) \
148         $(ALL_APIDOC_HS_DIRS) \
149         $(APIDOC_PY_DIR) \
150         $(COVERAGE_DIR) \
151         $(COVERAGE_HS_DIR) \
152         $(COVERAGE_PY_DIR) \
153         .hpc
154
155 BUILDTIME_DIRS = \
156         $(BUILDTIME_DIR_AUTOCREATE) \
157         doc/html \
158         doc/man-html
159
160 DIRCHECK_EXCLUDE = \
161         $(BUILDTIME_DIRS) \
162         ganeti-[0-9]*.[0-9]*.[0-9]* \
163         doc/html/_* \
164         doc/man-html/_* \
165         autom4te.cache
166
167 # some helper vars
168 COVERAGE_DIR = doc/coverage
169 COVERAGE_PY_DIR = $(COVERAGE_DIR)/py
170 COVERAGE_HS_DIR = $(COVERAGE_DIR)/hs
171 APIDOC_DIR = doc/api
172 APIDOC_PY_DIR = $(APIDOC_DIR)/py
173 APIDOC_HS_DIR = $(APIDOC_DIR)/hs
174
175 MAINTAINERCLEANFILES = \
176         $(maninput) \
177         doc/install-quick.rst \
178         doc/news.rst \
179         doc/upgrade.rst \
180         vcs-version
181
182 maintainer-clean-local:
183         rm -rf $(BUILDTIME_DIRS)
184
185 CLEANFILES = \
186         $(addsuffix /*.py[co],$(DIRS)) \
187         $(addsuffix /*.hi,$(HS_DIRS)) \
188         $(addsuffix /*.o,$(HS_DIRS)) \
189         $(PYTHON_BOOTSTRAP) \
190         epydoc.conf \
191         $(REPLACE_VARS_SED) \
192         $(SHELL_ENV_INIT) \
193         daemons/daemon-util \
194         daemons/ganeti-cleaner \
195         devel/squeeze-amd64.tar.gz \
196         devel/squeeze-amd64.conf \
197         $(mandocrst) \
198         doc/manpages-enabled.rst \
199         $(BUILT_EXAMPLES) \
200         doc/examples/bash_completion \
201         doc/examples/bash_completion-debug \
202         lib/_generated_rpc.py \
203         $(man_MANS) \
204         $(manhtml) \
205         tools/kvm-ifup \
206         tools/vif-ganeti \
207         tools/net-common \
208         tools/users-setup \
209         tools/vcluster-setup \
210         stamp-directories \
211         stamp-srclinks \
212         $(nodist_pkgpython_PYTHON) \
213         $(HS_ALL_PROGS) $(HS_BUILT_SRCS) \
214         $(HS_BUILT_TEST_HELPERS) \
215         src/ganeti-confd \
216         src/ganeti-luxid \
217         src/ganeti-mond \
218         .hpc/*.mix src/*.tix test/hs/*.tix \
219         doc/hs-lint.html
220
221 GENERATED_FILES = \
222         $(built_base_sources) \
223         $(BUILT_PYTHON_SOURCES) \
224         $(PYTHON_BOOTSTRAP)
225
226 HS_GENERATED_FILES =
227 if WANT_HTOOLS
228 HS_GENERATED_FILES += $(HS_PROGS)
229 if ENABLE_CONFD
230 HS_GENERATED_FILES += src/hconfd src/ganeti-confd src/hluxid src/ganeti-luxid
231 endif
232
233 if ENABLE_MOND
234 HS_GENERATED_FILES += src/ganeti-mond
235 endif
236 endif
237
238 built_base_sources = \
239         stamp-directories \
240         stamp-srclinks
241
242 built_python_base_sources = \
243         lib/_autoconf.py \
244         lib/_vcsversion.py
245
246 BUILT_PYTHON_SOURCES = \
247         $(built_python_base_sources) \
248         lib/_generated_rpc.py
249
250 # Generating the RPC wrappers depends on many things, so make sure
251 # it's built at the end of the built sources
252 lib/_generated_rpc.py: | $(built_base_sources) $(built_python_base_sources)
253
254 # these are all built from the underlying %.in sources
255 BUILT_EXAMPLES = \
256         doc/examples/ganeti-kvm-poweroff.initd \
257         doc/examples/ganeti.cron \
258         doc/examples/ganeti.initd \
259         doc/examples/ganeti.logrotate \
260         doc/examples/ganeti-master-role.ocf \
261         doc/examples/ganeti-node-role.ocf \
262         doc/examples/gnt-config-backup \
263         doc/examples/hooks/ipsec
264
265 nodist_pkgpython_PYTHON = \
266         $(BUILT_PYTHON_SOURCES)
267
268 noinst_PYTHON = \
269         lib/build/__init__.py \
270         lib/build/shell_example_lexer.py \
271         lib/build/sphinx_ext.py
272
273 pkgpython_PYTHON = \
274         lib/__init__.py \
275         lib/asyncnotifier.py \
276         lib/backend.py \
277         lib/bootstrap.py \
278         lib/cli.py \
279         lib/compat.py \
280         lib/config.py \
281         lib/constants.py \
282         lib/daemon.py \
283         lib/errors.py \
284         lib/hooksmaster.py \
285         lib/ht.py \
286         lib/jqueue.py \
287         lib/jstore.py \
288         lib/locking.py \
289         lib/luxi.py \
290         lib/mcpu.py \
291         lib/netutils.py \
292         lib/objects.py \
293         lib/opcodes.py \
294         lib/outils.py \
295         lib/ovf.py \
296         lib/pathutils.py \
297         lib/qlang.py \
298         lib/query.py \
299         lib/rpc.py \
300         lib/rpc_defs.py \
301         lib/runtime.py \
302         lib/serializer.py \
303         lib/ssconf.py \
304         lib/ssh.py \
305         lib/uidpool.py \
306         lib/vcluster.py \
307         lib/network.py \
308         lib/workerpool.py
309
310 client_PYTHON = \
311         lib/client/__init__.py \
312         lib/client/gnt_backup.py \
313         lib/client/gnt_cluster.py \
314         lib/client/gnt_debug.py \
315         lib/client/gnt_group.py \
316         lib/client/gnt_instance.py \
317         lib/client/gnt_job.py \
318         lib/client/gnt_node.py \
319         lib/client/gnt_network.py \
320         lib/client/gnt_os.py \
321         lib/client/gnt_storage.py
322
323 cmdlib_PYTHON = \
324         lib/cmdlib/__init__.py \
325         lib/cmdlib/backup.py \
326         lib/cmdlib/base.py \
327         lib/cmdlib/cluster.py \
328         lib/cmdlib/common.py \
329         lib/cmdlib/group.py \
330         lib/cmdlib/instance.py \
331         lib/cmdlib/instance_migration.py \
332         lib/cmdlib/instance_operation.py \
333         lib/cmdlib/instance_query.py \
334         lib/cmdlib/instance_storage.py \
335         lib/cmdlib/instance_utils.py \
336         lib/cmdlib/misc.py \
337         lib/cmdlib/network.py \
338         lib/cmdlib/node.py \
339         lib/cmdlib/operating_system.py \
340         lib/cmdlib/query.py \
341         lib/cmdlib/tags.py \
342         lib/cmdlib/test.py
343
344 hypervisor_PYTHON = \
345         lib/hypervisor/__init__.py \
346         lib/hypervisor/hv_base.py \
347         lib/hypervisor/hv_chroot.py \
348         lib/hypervisor/hv_fake.py \
349         lib/hypervisor/hv_kvm.py \
350         lib/hypervisor/hv_lxc.py \
351         lib/hypervisor/hv_xen.py
352
353 storage_PYTHON = \
354         lib/storage/__init__.py \
355         lib/storage/bdev.py \
356         lib/storage/base.py \
357         lib/storage/container.py \
358         lib/storage/drbd.py \
359         lib/storage/drbd_info.py \
360         lib/storage/drbd_cmdgen.py \
361         lib/storage/filestorage.py
362
363 rapi_PYTHON = \
364         lib/rapi/__init__.py \
365         lib/rapi/baserlib.py \
366         lib/rapi/client.py \
367         lib/rapi/client_utils.py \
368         lib/rapi/connector.py \
369         lib/rapi/rlib2.py \
370         lib/rapi/testutils.py
371
372 http_PYTHON = \
373         lib/http/__init__.py \
374         lib/http/auth.py \
375         lib/http/client.py \
376         lib/http/server.py
377
378 confd_PYTHON = \
379         lib/confd/__init__.py \
380         lib/confd/client.py
381
382 masterd_PYTHON = \
383         lib/masterd/__init__.py \
384         lib/masterd/iallocator.py \
385         lib/masterd/instance.py
386
387 impexpd_PYTHON = \
388         lib/impexpd/__init__.py
389
390 watcher_PYTHON = \
391         lib/watcher/__init__.py \
392         lib/watcher/nodemaint.py \
393         lib/watcher/state.py
394
395 server_PYTHON = \
396         lib/server/__init__.py \
397         lib/server/masterd.py \
398         lib/server/noded.py \
399         lib/server/rapi.py
400
401 pytools_PYTHON = \
402         lib/tools/__init__.py \
403         lib/tools/burnin.py \
404         lib/tools/ensure_dirs.py \
405         lib/tools/node_cleanup.py \
406         lib/tools/node_daemon_setup.py \
407         lib/tools/prepare_node_join.py
408
409 utils_PYTHON = \
410         lib/utils/__init__.py \
411         lib/utils/algo.py \
412         lib/utils/filelock.py \
413         lib/utils/hash.py \
414         lib/utils/io.py \
415         lib/utils/log.py \
416         lib/utils/lvm.py \
417         lib/utils/mlock.py \
418         lib/utils/nodesetup.py \
419         lib/utils/process.py \
420         lib/utils/retry.py \
421         lib/utils/storage.py \
422         lib/utils/text.py \
423         lib/utils/wrapper.py \
424         lib/utils/x509.py
425
426 docinput = \
427         doc/conf.py \
428         doc/css/style.css \
429         doc/admin.rst \
430         doc/cluster-merge.rst \
431         doc/design-2.0.rst \
432         doc/design-2.1.rst \
433         doc/design-2.2.rst \
434         doc/design-2.3.rst \
435         doc/design-2.4.rst \
436         doc/design-2.5.rst \
437         doc/design-2.6.rst \
438         doc/design-2.7.rst \
439         doc/design-2.8.rst \
440         doc/design-autorepair.rst \
441         doc/design-bulk-create.rst \
442         doc/design-chained-jobs.rst \
443         doc/design-cpu-pinning.rst \
444         doc/design-device-uuid-name.rst \
445         doc/design-draft.rst \
446         doc/design-hotplug.rst \
447         doc/design-htools-2.3.rst \
448         doc/design-http-server.rst \
449         doc/design-impexp2.rst \
450         doc/design-internal-shutdown.rst \
451         doc/design-lu-generated-jobs.rst \
452         doc/design-linuxha.rst \
453         doc/design-multi-reloc.rst \
454         doc/design-network.rst \
455         doc/design-node-add.rst \
456         doc/design-oob.rst \
457         doc/design-ovf-support.rst \
458         doc/design-opportunistic-locking.rst \
459         doc/design-optables.rst \
460         doc/design-partitioned.rst \
461         doc/design-query-splitting.rst \
462         doc/design-query2.rst \
463         doc/design-reason-trail.rst \
464         doc/design-resource-model.rst \
465         doc/design-restricted-commands.rst \
466         doc/design-shared-storage.rst \
467         doc/design-monitoring-agent.rst \
468         doc/design-virtual-clusters.rst \
469         doc/design-x509-ca.rst \
470         doc/design-hroller.rst \
471         doc/design-storagetypes.rst \
472         doc/devnotes.rst \
473         doc/glossary.rst \
474         doc/hooks.rst \
475         doc/iallocator.rst \
476         doc/index.rst \
477         doc/install-quick.rst \
478         doc/install.rst \
479         doc/locking.rst \
480         doc/manpages-disabled.rst \
481         doc/move-instance.rst \
482         doc/news.rst \
483         doc/ovfconverter.rst \
484         doc/rapi.rst \
485         doc/security.rst \
486         doc/upgrade.rst \
487         doc/virtual-cluster.rst \
488         doc/walkthrough.rst
489
490 # Generates file names such as "doc/man-gnt-instance.rst"
491 mandocrst = $(addprefix doc/man-,$(notdir $(manrst)))
492
493 # Haskell programs to be installed in $PREFIX/bin
494 HS_BIN_PROGS=src/htools
495
496 # Haskell programs to be installed in the MYEXECLIB dir
497 if ENABLE_MOND
498 HS_MYEXECLIB_PROGS=src/mon-collector
499 else
500 HS_MYEXECLIB_PROGS=
501 endif
502
503 # Haskell programs to be compiled by "make really-all"
504 HS_COMPILE_PROGS= \
505         src/ganeti-mond \
506         src/hconfd \
507         src/hluxid \
508         src/rpc-test
509
510 # All Haskell non-test programs to be compiled but not automatically installed
511 HS_PROGS = $(HS_BIN_PROGS) $(HS_MYEXECLIB_PROGS)
512
513 HS_BIN_ROLES = harep hbal hscan hspace hinfo hcheck hroller
514 HS_HTOOLS_PROGS = $(HS_BIN_ROLES) hail
515
516 HS_ALL_PROGS = \
517         $(HS_PROGS) \
518         test/hs/hpc-htools \
519         test/hs/hpc-mon-collector \
520         test/hs/htest \
521         $(HS_COMPILE_PROGS)
522
523 HS_PROG_SRCS = $(patsubst %,%.hs,$(HS_ALL_PROGS))
524 HS_BUILT_TEST_HELPERS = $(HS_BIN_ROLES:%=test/hs/%) test/hs/hail
525
526 HFLAGS = \
527         -O -Wall -Werror -isrc \
528         -fwarn-monomorphism-restriction \
529         -fwarn-tabs \
530         $(GHC_BYVERSION_FLAGS)
531
532 # extra flags that can be overriden on the command line (e.g. -Wwarn, etc.)
533 HEXTRA =
534 # internal extra flags (used for test/hs/htest mainly)
535 HEXTRA_INT =
536 # exclude options for coverage reports
537 HPCEXCL = --exclude Main \
538         --exclude Ganeti.Constants \
539         --exclude Ganeti.HTools.QC \
540         --exclude Ganeti.THH \
541         --exclude Ganeti.Version \
542         --exclude Test.Ganeti.Attoparsec \
543         --exclude Test.Ganeti.TestCommon \
544         --exclude Test.Ganeti.TestHTools \
545         --exclude Test.Ganeti.TestHelper \
546         --exclude Test.Ganeti.TestImports \
547         $(patsubst src.%,--exclude Test.%,$(subst /,.,$(patsubst %.hs,%, $(HS_LIB_SRCS))))
548
549 HS_LIB_SRCS = \
550         src/Ganeti/BasicTypes.hs \
551         src/Ganeti/Common.hs \
552         src/Ganeti/Compat.hs \
553         src/Ganeti/Confd/Client.hs \
554         src/Ganeti/Confd/ClientFunctions.hs \
555         src/Ganeti/Confd/Server.hs \
556         src/Ganeti/Confd/Types.hs \
557         src/Ganeti/Confd/Utils.hs \
558         src/Ganeti/Config.hs \
559         src/Ganeti/ConfigReader.hs \
560         src/Ganeti/Cpu/LoadParser.hs \
561         src/Ganeti/Cpu/Types.hs \
562         src/Ganeti/Curl/Multi.hs \
563         src/Ganeti/Daemon.hs \
564         src/Ganeti/DataCollectors/CLI.hs \
565         src/Ganeti/DataCollectors/Diskstats.hs \
566         src/Ganeti/DataCollectors/Drbd.hs \
567         src/Ganeti/DataCollectors/InstStatus.hs \
568         src/Ganeti/DataCollectors/InstStatusTypes.hs \
569         src/Ganeti/DataCollectors/Lv.hs \
570         src/Ganeti/DataCollectors/Program.hs \
571         src/Ganeti/DataCollectors/Types.hs \
572         src/Ganeti/Errors.hs \
573         src/Ganeti/HTools/Backend/IAlloc.hs \
574         src/Ganeti/HTools/Backend/Luxi.hs \
575         src/Ganeti/HTools/Backend/Rapi.hs \
576         src/Ganeti/HTools/Backend/Simu.hs \
577         src/Ganeti/HTools/Backend/Text.hs \
578         src/Ganeti/HTools/CLI.hs \
579         src/Ganeti/HTools/Cluster.hs \
580         src/Ganeti/HTools/Container.hs \
581         src/Ganeti/HTools/ExtLoader.hs \
582         src/Ganeti/HTools/Graph.hs \
583         src/Ganeti/HTools/Group.hs \
584         src/Ganeti/HTools/Instance.hs \
585         src/Ganeti/HTools/Loader.hs \
586         src/Ganeti/HTools/Nic.hs \
587         src/Ganeti/HTools/Node.hs \
588         src/Ganeti/HTools/PeerMap.hs \
589         src/Ganeti/HTools/Program/Hail.hs \
590         src/Ganeti/HTools/Program/Harep.hs \
591         src/Ganeti/HTools/Program/Hbal.hs \
592         src/Ganeti/HTools/Program/Hcheck.hs \
593         src/Ganeti/HTools/Program/Hinfo.hs \
594         src/Ganeti/HTools/Program/Hscan.hs \
595         src/Ganeti/HTools/Program/Hspace.hs \
596         src/Ganeti/HTools/Program/Hroller.hs \
597         src/Ganeti/HTools/Program/Main.hs \
598         src/Ganeti/HTools/Types.hs \
599         src/Ganeti/Hypervisor/Xen.hs \
600         src/Ganeti/Hypervisor/Xen/XmParser.hs \
601         src/Ganeti/Hypervisor/Xen/Types.hs \
602         src/Ganeti/Hash.hs \
603         src/Ganeti/JQueue.hs \
604         src/Ganeti/JSON.hs \
605         src/Ganeti/Jobs.hs \
606         src/Ganeti/Logging.hs \
607         src/Ganeti/Luxi.hs \
608         src/Ganeti/Monitoring/Server.hs \
609         src/Ganeti/Network.hs \
610         src/Ganeti/Objects.hs \
611         src/Ganeti/OpCodes.hs \
612         src/Ganeti/OpParams.hs \
613         src/Ganeti/Path.hs \
614         src/Ganeti/Parsers.hs \
615         src/Ganeti/Query/Cluster.hs \
616         src/Ganeti/Query/Common.hs \
617         src/Ganeti/Query/Export.hs \
618         src/Ganeti/Query/Filter.hs \
619         src/Ganeti/Query/Group.hs \
620         src/Ganeti/Query/Job.hs \
621         src/Ganeti/Query/Language.hs \
622         src/Ganeti/Query/Network.hs \
623         src/Ganeti/Query/Node.hs \
624         src/Ganeti/Query/Query.hs \
625         src/Ganeti/Query/Server.hs \
626         src/Ganeti/Query/Types.hs \
627         src/Ganeti/Rpc.hs \
628         src/Ganeti/Runtime.hs \
629         src/Ganeti/Ssconf.hs \
630         src/Ganeti/Storage/Diskstats/Parser.hs \
631         src/Ganeti/Storage/Diskstats/Types.hs \
632         src/Ganeti/Storage/Drbd/Parser.hs \
633         src/Ganeti/Storage/Drbd/Types.hs \
634         src/Ganeti/Storage/Lvm/LVParser.hs \
635         src/Ganeti/Storage/Lvm/Types.hs \
636         src/Ganeti/Storage/Utils.hs \
637         src/Ganeti/THH.hs \
638         src/Ganeti/Types.hs \
639         src/Ganeti/Utils.hs
640
641 HS_TEST_SRCS = \
642         test/hs/Test/Ganeti/Attoparsec.hs \
643         test/hs/Test/Ganeti/BasicTypes.hs \
644         test/hs/Test/Ganeti/Common.hs \
645         test/hs/Test/Ganeti/Confd/Types.hs \
646         test/hs/Test/Ganeti/Confd/Utils.hs \
647         test/hs/Test/Ganeti/Daemon.hs \
648         test/hs/Test/Ganeti/Errors.hs \
649         test/hs/Test/Ganeti/HTools/Backend/Simu.hs \
650         test/hs/Test/Ganeti/HTools/Backend/Text.hs \
651         test/hs/Test/Ganeti/HTools/CLI.hs \
652         test/hs/Test/Ganeti/HTools/Cluster.hs \
653         test/hs/Test/Ganeti/HTools/Container.hs \
654         test/hs/Test/Ganeti/HTools/Graph.hs \
655         test/hs/Test/Ganeti/HTools/Instance.hs \
656         test/hs/Test/Ganeti/HTools/Loader.hs \
657         test/hs/Test/Ganeti/HTools/Node.hs \
658         test/hs/Test/Ganeti/HTools/PeerMap.hs \
659         test/hs/Test/Ganeti/HTools/Types.hs \
660         test/hs/Test/Ganeti/Hypervisor/Xen/XmParser.hs \
661         test/hs/Test/Ganeti/JSON.hs \
662         test/hs/Test/Ganeti/Jobs.hs \
663         test/hs/Test/Ganeti/JQueue.hs \
664         test/hs/Test/Ganeti/Luxi.hs \
665         test/hs/Test/Ganeti/Network.hs \
666         test/hs/Test/Ganeti/Objects.hs \
667         test/hs/Test/Ganeti/OpCodes.hs \
668         test/hs/Test/Ganeti/Query/Filter.hs \
669         test/hs/Test/Ganeti/Query/Language.hs \
670         test/hs/Test/Ganeti/Query/Network.hs \
671         test/hs/Test/Ganeti/Query/Query.hs \
672         test/hs/Test/Ganeti/Rpc.hs \
673         test/hs/Test/Ganeti/Runtime.hs \
674         test/hs/Test/Ganeti/Ssconf.hs \
675         test/hs/Test/Ganeti/Storage/Diskstats/Parser.hs \
676         test/hs/Test/Ganeti/Storage/Drbd/Parser.hs \
677         test/hs/Test/Ganeti/Storage/Drbd/Types.hs \
678         test/hs/Test/Ganeti/Storage/Lvm/LVParser.hs \
679         test/hs/Test/Ganeti/THH.hs \
680         test/hs/Test/Ganeti/TestCommon.hs \
681         test/hs/Test/Ganeti/TestHTools.hs \
682         test/hs/Test/Ganeti/TestHelper.hs \
683         test/hs/Test/Ganeti/Types.hs \
684         test/hs/Test/Ganeti/Utils.hs
685
686 HS_LIBTEST_SRCS = $(HS_LIB_SRCS) $(HS_TEST_SRCS)
687
688 HS_BUILT_SRCS = \
689         test/hs/Test/Ganeti/TestImports.hs \
690         src/Ganeti/Constants.hs \
691         src/Ganeti/Curl/Internal.hs \
692         src/Ganeti/Version.hs
693 HS_BUILT_SRCS_IN = \
694         $(patsubst %,%.in,$(filter-out src/Ganeti/Curl/Internal.hs,$(HS_BUILT_SRCS))) \
695         src/Ganeti/Curl/Internal.hsc
696
697 HS_LIBTESTBUILT_SRCS = $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS)
698
699 $(RUN_IN_TEMPDIR): | stamp-directories
700
701 doc/html/index.html: ENABLE_MANPAGES =
702 doc/man-html/index.html: ENABLE_MANPAGES = 1
703 doc/man-html/index.html: doc/manpages-enabled.rst $(mandocrst)
704
705 # Note: we use here an order-only prerequisite, as the contents of
706 # _autoconf.py are not actually influencing the html build output: it
707 # has to exist in order for the sphinx module to be loaded
708 # successfully, but we certainly don't want the docs to be rebuilt if
709 # it changes
710 doc/html/index.html doc/man-html/index.html: $(docinput) doc/conf.py \
711         configure.ac $(RUN_IN_TEMPDIR) lib/build/sphinx_ext.py \
712         lib/build/shell_example_lexer.py lib/opcodes.py lib/ht.py \
713         doc/css/style.css lib/rapi/connector.py lib/rapi/rlib2.py \
714         autotools/sphinx-wrapper | $(BUILT_PYTHON_SOURCES)
715         @test -n "$(SPHINX)" || \
716             { echo 'sphinx-build' not found during configure; exit 1; }
717 if !MANPAGES_IN_DOC
718         if test -n '$(ENABLE_MANPAGES)'; then \
719           echo 'Man pages in documentation were disabled at configure time' >&2; \
720           exit 1; \
721         fi
722 endif
723 ## Sphinx provides little control over what content should be included. Some
724 ## mechanisms exist, but they all have drawbacks or actual issues. Since we
725 ## build two different versions of the documentation--once without man pages and
726 ## once, if enabled, with them--some control is necessary. xmpp-wrapper provides
727 ## us with this, but requires running in a temporary directory. It moves the
728 ## correct files into place depending on environment variables.
729         dir=$(dir $@) && \
730         @mkdir_p@ $$dir && \
731         PYTHONPATH=. ENABLE_MANPAGES=$(ENABLE_MANPAGES) COPY_DOC=1 \
732         $(RUN_IN_TEMPDIR) autotools/sphinx-wrapper $(SPHINX) -q -W -b html \
733             -d . \
734             -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
735             -D release="$(PACKAGE_VERSION)" \
736             -D graphviz_dot="$(DOT)" \
737             -D enable_manpages="$(ENABLE_MANPAGES)" \
738             doc $(CURDIR)/$$dir && \
739         rm -f $$dir/.buildinfo $$dir/objects.inv
740         touch $@
741
742 doc/html: doc/html/index.html
743
744 doc/man-html: doc/man-html/index.html
745
746 doc/install-quick.rst: INSTALL
747 doc/news.rst: NEWS
748 doc/upgrade.rst: UPGRADE
749
750 doc/install-quick.rst doc/news.rst doc/upgrade.rst:
751         set -e; \
752         { echo '.. This file is automatically updated at build time from $<.'; \
753           echo '.. Do not edit.'; \
754           echo; \
755           cat $<; \
756         } > $@
757
758 doc/manpages-enabled.rst: Makefile | $(built_base_sources)
759         { echo '.. This file is automatically generated, do not edit!'; \
760           echo ''; \
761           echo 'Man pages'; \
762           echo '========='; \
763           echo; \
764           echo '.. toctree::'; \
765           echo '   :maxdepth: 1'; \
766           echo; \
767           for i in $(notdir $(mandocrst)); do \
768             echo "   $$i"; \
769           done | LC_ALL=C sort; \
770         } > $@
771
772 doc/man-%.rst: man/%.gen Makefile $(REPLACE_VARS_SED) | $(built_base_sources)
773 if MANPAGES_IN_DOC
774         { echo '.. This file is automatically updated at build time from $<.'; \
775           echo '.. Do not edit.'; \
776           echo; \
777           echo "$*"; \
778           echo '=========================================='; \
779           tail -n +3 $< | sed -f $(REPLACE_VARS_SED); \
780         } > $@
781 else
782         echo 'Man pages in documentation were disabled at configure time' >&2; \
783         exit 1;
784 endif
785
786 # Things to build but not to install (add it to EXTRA_DIST if it should be
787 # distributed)
788 noinst_DATA = \
789         doc/html \
790         $(BUILT_EXAMPLES) \
791         doc/examples/bash_completion \
792         doc/examples/bash_completion-debug \
793         $(manhtml)
794
795 if MANPAGES_IN_DOC
796 noinst_DATA += doc/man-html
797 endif
798
799 gnt_scripts = \
800         scripts/gnt-backup \
801         scripts/gnt-cluster \
802         scripts/gnt-debug \
803         scripts/gnt-group \
804         scripts/gnt-instance \
805         scripts/gnt-job \
806         scripts/gnt-network \
807         scripts/gnt-node \
808         scripts/gnt-os \
809         scripts/gnt-storage
810
811 PYTHON_BOOTSTRAP_SBIN = \
812         daemons/ganeti-masterd \
813         daemons/ganeti-noded \
814         daemons/ganeti-rapi \
815         daemons/ganeti-watcher \
816         $(gnt_scripts)
817
818 PYTHON_BOOTSTRAP = \
819         $(PYTHON_BOOTSTRAP_SBIN) \
820         tools/burnin \
821         tools/ensure-dirs \
822         tools/node-cleanup \
823         tools/node-daemon-setup \
824         tools/prepare-node-join
825
826 qa_scripts = \
827         qa/__init__.py \
828         qa/ganeti-qa.py \
829         qa/qa_cluster.py \
830         qa/qa_config.py \
831         qa/qa_daemon.py \
832         qa/qa_env.py \
833         qa/qa_error.py \
834         qa/qa_group.py \
835         qa/qa_instance.py \
836         qa/qa_instance_utils.py \
837         qa/qa_job.py \
838         qa/qa_monitoring.py \
839         qa/qa_node.py \
840         qa/qa_os.py \
841         qa/qa_rapi.py \
842         qa/qa_tags.py \
843         qa/qa_utils.py
844
845 bin_SCRIPTS =
846 if WANT_HTOOLS
847 bin_SCRIPTS += $(HS_BIN_PROGS)
848 install-exec-hook:
849         @mkdir_p@ $(DESTDIR)$(iallocatorsdir)
850 # FIXME: this is a hardcoded logic, instead of auto-resolving
851         $(LN_S) -f ../../../bin/htools \
852           $(DESTDIR)$(iallocatorsdir)/hail
853         for role in $(HS_BIN_ROLES); do \
854           $(LN_S) -f htools $(DESTDIR)$(bindir)/$$role ; \
855         done
856 endif
857
858 $(HS_ALL_PROGS): %: %.hs $(HS_LIBTESTBUILT_SRCS) Makefile
859         @if [ "$(notdir $@)" = "test" ] && [ "$(HS_NODEV)" ]; then \
860           echo "Error: cannot run unittests without the development" \
861                " libraries (see devnotes.rst)" 1>&2; \
862           exit 1; \
863         fi
864         @rm -f $(notdir $@).tix
865         $(GHC) --make \
866           $(HFLAGS) \
867           $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
868           -osuf $(notdir $@).o -hisuf $(notdir $@).hi \
869           $(HEXTRA) $(HEXTRA_INT) $@
870         @touch "$@"
871
872 # for the test/hs/htest binary, we need to enable profiling/coverage
873 test/hs/htest: HEXTRA_INT=-fhpc -itest/hs
874
875 # we compile the hpc-htools binary with the program coverage
876 test/hs/hpc-htools: HEXTRA_INT=-fhpc
877
878 # we compile the hpc-mon-collector binary with the program coverage
879 test/hs/hpc-mon-collector: HEXTRA_INT=-fhpc
880
881 # test dependency
882 test/hs/offline-test.sh: test/hs/hpc-htools test/hs/hpc-mon-collector
883
884 # rules for building profiling-enabled versions of the haskell
885 # programs: hs-prof does the full two-step build, whereas
886 # hs-prof-quick does only the final rebuild (hs-prof must have been
887 # run before)
888 .PHONY: hs-prof hs-prof-quick
889 hs-prof:
890         @if [ -z "$(TARGET)" ]; then \
891           echo "You need to define TARGET when running this rule" 1>&2; \
892           exit 1; \
893         fi
894         $(MAKE) $(AM_MAKEFLAGS) clean
895         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf o"
896         rm -f $(HS_ALL_PROGS)
897         $(MAKE) $(AM_MAKEFLAGS) hs-prof-quick
898
899 hs-prof-quick:
900         @if [ -z "$(TARGET)" ]; then \
901           echo "You need to define TARGET when running this rule" 1>&2; \
902           exit 1; \
903         fi
904         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf prof_o -prof -auto-all"
905
906 dist_sbin_SCRIPTS = \
907         tools/ganeti-listrunner
908
909 nodist_sbin_SCRIPTS = \
910         $(PYTHON_BOOTSTRAP_SBIN) \
911         daemons/ganeti-cleaner
912
913 if ENABLE_CONFD
914 src/ganeti-confd: src/hconfd
915         cp -f $< $@
916
917 src/ganeti-luxid: src/hluxid
918         cp -f $< $@
919
920 nodist_sbin_SCRIPTS += src/ganeti-confd
921 nodist_sbin_SCRIPTS += src/ganeti-luxid
922 endif
923
924 if ENABLE_MOND
925 nodist_sbin_SCRIPTS += src/ganeti-mond
926 endif
927
928 python_scripts = \
929         tools/cfgshell \
930         tools/cfgupgrade \
931         tools/cfgupgrade12 \
932         tools/cluster-merge \
933         tools/confd-client \
934         tools/fmtjson \
935         tools/lvmstrap \
936         tools/move-instance \
937         tools/ovfconverter \
938         tools/sanitize-config
939
940 dist_tools_SCRIPTS = \
941         $(python_scripts) \
942         tools/burnin \
943         tools/kvm-console-wrapper \
944         tools/master-ip-setup \
945         tools/xen-console-wrapper
946
947 nodist_tools_python_scripts = \
948         tools/node-cleanup
949
950 nodist_tools_SCRIPTS = \
951         $(nodist_tools_python_scripts) \
952         tools/users-setup \
953         tools/vcluster-setup
954
955 pkglib_python_scripts = \
956         daemons/import-export \
957         tools/check-cert-expired
958
959 nodist_pkglib_python_scripts = \
960         tools/ensure-dirs \
961         tools/node-daemon-setup \
962         tools/prepare-node-join
963
964 myexeclib_SCRIPTS = \
965         daemons/daemon-util \
966         tools/kvm-ifup \
967         tools/vif-ganeti \
968         tools/net-common \
969         $(pkglib_python_scripts) \
970         $(HS_MYEXECLIB_PROGS)
971
972 nodist_myexeclib_SCRIPTS = \
973         $(nodist_pkglib_python_scripts)
974
975 EXTRA_DIST = \
976         NEWS \
977         UPGRADE \
978         epydoc.conf.in \
979         pylintrc \
980         autotools/build-bash-completion \
981         autotools/build-rpc \
982         autotools/check-header \
983         autotools/check-imports \
984         autotools/check-man-dashes \
985         autotools/check-man-references \
986         autotools/check-man-warnings \
987         autotools/check-news \
988         autotools/check-python-code \
989         autotools/check-tar \
990         autotools/check-version \
991         autotools/convert-constants \
992         autotools/docpp \
993         autotools/gen-py-coverage \
994         autotools/sphinx-wrapper \
995         autotools/testrunner \
996         autotools/wrong-hardcoded-paths \
997         $(RUN_IN_TEMPDIR) \
998         daemons/daemon-util.in \
999         daemons/ganeti-cleaner.in \
1000         $(pkglib_python_scripts) \
1001         devel/upload \
1002         devel/webserver \
1003         tools/kvm-ifup.in \
1004         tools/vif-ganeti.in \
1005         tools/net-common.in \
1006         tools/users-setup.in \
1007         tools/vcluster-setup.in \
1008         $(docinput) \
1009         doc/html \
1010         $(BUILT_EXAMPLES:%=%.in) \
1011         doc/examples/ganeti.default \
1012         doc/examples/ganeti.default-debug \
1013         doc/examples/hooks/ethers \
1014         doc/examples/gnt-debug/README \
1015         doc/examples/gnt-debug/delay0.json \
1016         doc/examples/gnt-debug/delay50.json \
1017         test/py/lockperf.py \
1018         test/py/testutils.py \
1019         test/py/mocks.py \
1020         $(dist_TESTS) \
1021         $(TEST_FILES) \
1022         man/footer.rst \
1023         $(manrst) \
1024         $(maninput) \
1025         qa/qa-sample.json \
1026         $(qa_scripts) \
1027         $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS_IN) \
1028         $(HS_PROG_SRCS) \
1029         src/lint-hints.hs \
1030         test/hs/cli-tests-defs.sh \
1031         test/hs/offline-test.sh \
1032         .ghci
1033
1034 man_MANS = \
1035         man/ganeti-cleaner.8 \
1036         man/ganeti-confd.8 \
1037         man/ganeti-luxid.8 \
1038         man/ganeti-listrunner.8 \
1039         man/ganeti-masterd.8 \
1040         man/ganeti-mond.8 \
1041         man/ganeti-noded.8 \
1042         man/ganeti-os-interface.7 \
1043         man/ganeti-extstorage-interface.7 \
1044         man/ganeti-rapi.8 \
1045         man/ganeti-watcher.8 \
1046         man/ganeti.7 \
1047         man/gnt-backup.8 \
1048         man/gnt-cluster.8 \
1049         man/gnt-debug.8 \
1050         man/gnt-group.8 \
1051         man/gnt-network.8 \
1052         man/gnt-instance.8 \
1053         man/gnt-job.8 \
1054         man/gnt-node.8 \
1055         man/gnt-os.8 \
1056         man/gnt-storage.8 \
1057         man/hail.1 \
1058         man/harep.1 \
1059         man/hbal.1 \
1060         man/hcheck.1 \
1061         man/hinfo.1 \
1062         man/hscan.1 \
1063         man/hspace.1 \
1064         man/hroller.1 \
1065         man/htools.1 \
1066         man/mon-collector.7
1067
1068 # Remove extensions from all filenames in man_MANS
1069 mannoext = $(patsubst %.1,%,$(patsubst %.7,%,$(patsubst %.8,%,$(man_MANS))))
1070
1071 manrst = $(patsubst %,%.rst,$(mannoext))
1072 manhtml = $(patsubst %.rst,%.html,$(manrst))
1073 mangen = $(patsubst %.rst,%.gen,$(manrst))
1074 maninput = \
1075         $(patsubst %.1,%.1.in,$(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS)))) \
1076         $(patsubst %.html,%.html.in,$(manhtml)) \
1077         $(mangen)
1078
1079 TEST_FILES = \
1080         test/autotools/autotools-check-news.test \
1081         test/data/htools/clean-nonzero-score.data \
1082         test/data/htools/common-suffix.data \
1083         test/data/htools/empty-cluster.data \
1084         test/data/htools/hail-alloc-drbd.json \
1085         test/data/htools/hail-alloc-invalid-network.json \
1086         test/data/htools/hail-alloc-invalid-twodisks.json \
1087         test/data/htools/hail-alloc-restricted-network.json \
1088         test/data/htools/hail-alloc-spindles.json \
1089         test/data/htools/hail-alloc-twodisks.json \
1090         test/data/htools/hail-change-group.json \
1091         test/data/htools/hail-invalid-reloc.json \
1092         test/data/htools/hail-node-evac.json \
1093         test/data/htools/hail-reloc-drbd.json \
1094         test/data/htools/hbal-excl-tags.data \
1095         test/data/htools/hbal-split-insts.data \
1096         test/data/htools/hspace-tiered-dualspec-exclusive.data \
1097         test/data/htools/hspace-tiered-dualspec.data \
1098         test/data/htools/hspace-tiered-exclusive.data \
1099         test/data/htools/hspace-tiered-ipolicy.data \
1100         test/data/htools/hspace-tiered-mixed.data \
1101         test/data/htools/hspace-tiered-resourcetypes.data \
1102         test/data/htools/hspace-tiered-vcpu.data \
1103         test/data/htools/hspace-tiered.data \
1104         test/data/htools/invalid-node.data \
1105         test/data/htools/missing-resources.data \
1106         test/data/htools/multiple-master.data \
1107         test/data/htools/multiple-tags.data \
1108         test/data/htools/n1-failure.data \
1109         test/data/htools/rapi/groups.json \
1110         test/data/htools/rapi/info.json \
1111         test/data/htools/rapi/instances.json \
1112         test/data/htools/rapi/nodes.json \
1113         test/data/htools/hroller-full.data \
1114         test/data/htools/hroller-nodegroups.data \
1115         test/data/htools/hroller-nonredundant.data \
1116         test/data/htools/hroller-online.data \
1117         test/data/htools/unique-reboot-order.data \
1118         test/hs/shelltests/htools-balancing.test \
1119         test/hs/shelltests/htools-basic.test \
1120         test/hs/shelltests/htools-dynutil.test \
1121         test/hs/shelltests/htools-excl.test \
1122         test/hs/shelltests/htools-hail.test \
1123         test/hs/shelltests/htools-hroller.test \
1124         test/hs/shelltests/htools-hspace.test \
1125         test/hs/shelltests/htools-invalid.test \
1126         test/hs/shelltests/htools-multi-group.test \
1127         test/hs/shelltests/htools-no-backend.test \
1128         test/hs/shelltests/htools-rapi.test \
1129         test/hs/shelltests/htools-single-group.test \
1130         test/hs/shelltests/htools-text-backend.test \
1131         test/hs/shelltests/htools-mon-collector.test \
1132         test/data/bdev-drbd-8.0.txt \
1133         test/data/bdev-drbd-8.3.txt \
1134         test/data/bdev-drbd-8.4.txt \
1135         test/data/bdev-drbd-8.4-no-disk-params.txt \
1136         test/data/bdev-drbd-disk.txt \
1137         test/data/bdev-drbd-net-ip4.txt \
1138         test/data/bdev-drbd-net-ip6.txt \
1139         test/data/bdev-rbd/json_output_empty.txt \
1140         test/data/bdev-rbd/json_output_extra_matches.txt \
1141         test/data/bdev-rbd/json_output_no_matches.txt \
1142         test/data/bdev-rbd/json_output_ok.txt \
1143         test/data/bdev-rbd/plain_output_new_extra_matches.txt \
1144         test/data/bdev-rbd/plain_output_new_no_matches.txt \
1145         test/data/bdev-rbd/plain_output_new_ok.txt \
1146         test/data/bdev-rbd/plain_output_old_empty.txt \
1147         test/data/bdev-rbd/plain_output_old_extra_matches.txt \
1148         test/data/bdev-rbd/plain_output_old_no_matches.txt \
1149         test/data/bdev-rbd/plain_output_old_ok.txt \
1150         test/data/bdev-rbd/output_invalid.txt \
1151         test/data/cert1.pem \
1152         test/data/cert2.pem \
1153         test/data/cluster_config_2.7.json \
1154         test/data/cluster_config_2.8.json \
1155         test/data/cluster_config_2.9.json \
1156         test/data/instance-minor-pairing.txt \
1157         test/data/instance-prim-sec.txt \
1158         test/data/ip-addr-show-dummy0.txt \
1159         test/data/ip-addr-show-lo-ipv4.txt \
1160         test/data/ip-addr-show-lo-ipv6.txt \
1161         test/data/ip-addr-show-lo-oneline-ipv4.txt \
1162         test/data/ip-addr-show-lo-oneline-ipv6.txt \
1163         test/data/ip-addr-show-lo-oneline.txt \
1164         test/data/ip-addr-show-lo.txt \
1165         test/data/kvm_0.12.5_help.txt \
1166         test/data/kvm_0.15.90_help.txt \
1167         test/data/kvm_0.9.1_help.txt \
1168         test/data/kvm_0.9.1_help_boot_test.txt \
1169         test/data/kvm_1.0_help.txt \
1170         test/data/kvm_1.1.2_help.txt \
1171         test/data/lvs_lv.txt \
1172         test/data/NEWS_OK.txt \
1173         test/data/NEWS_previous_unreleased.txt \
1174         test/data/ovfdata/compr_disk.vmdk.gz \
1175         test/data/ovfdata/config.ini \
1176         test/data/ovfdata/corrupted_resources.ovf \
1177         test/data/ovfdata/empty.ini \
1178         test/data/ovfdata/empty.ovf \
1179         test/data/ovfdata/ganeti.mf \
1180         test/data/ovfdata/ganeti.ovf \
1181         test/data/ovfdata/gzip_disk.ovf \
1182         test/data/ovfdata/new_disk.vmdk \
1183         test/data/ovfdata/no_disk.ini \
1184         test/data/ovfdata/no_disk_in_ref.ovf \
1185         test/data/ovfdata/no_os.ini \
1186         test/data/ovfdata/no_ovf.ova \
1187         test/data/ovfdata/other/rawdisk.raw \
1188         test/data/ovfdata/ova.ova \
1189         test/data/ovfdata/rawdisk.raw \
1190         test/data/ovfdata/second_disk.vmdk \
1191         test/data/ovfdata/unsafe_path.ini \
1192         test/data/ovfdata/virtualbox.ovf \
1193         test/data/ovfdata/wrong_config.ini \
1194         test/data/ovfdata/wrong_extension.ovd \
1195         test/data/ovfdata/wrong_manifest.mf \
1196         test/data/ovfdata/wrong_manifest.ovf \
1197         test/data/ovfdata/wrong_ova.ova \
1198         test/data/ovfdata/wrong_xml.ovf \
1199         test/data/proc_diskstats.txt \
1200         test/data/proc_drbd8.txt \
1201         test/data/proc_drbd80-emptyline.txt \
1202         test/data/proc_drbd80-emptyversion.txt \
1203         test/data/proc_drbd83.txt \
1204         test/data/proc_drbd83_sync.txt \
1205         test/data/proc_drbd83_sync_want.txt \
1206         test/data/proc_drbd83_sync_krnl2.6.39.txt \
1207         test/data/proc_drbd84.txt \
1208         test/data/proc_drbd84_sync.txt \
1209         test/data/qa-minimal-nodes-instances-only.json \
1210         test/data/sys_drbd_usermode_helper.txt \
1211         test/data/vgreduce-removemissing-2.02.02.txt \
1212         test/data/vgreduce-removemissing-2.02.66-fail.txt \
1213         test/data/vgreduce-removemissing-2.02.66-ok.txt \
1214         test/data/vgs-missing-pvs-2.02.02.txt \
1215         test/data/vgs-missing-pvs-2.02.66.txt \
1216         test/data/xen-xm-info-4.0.1.txt \
1217         test/data/xen-xm-list-4.0.1-dom0-only.txt \
1218         test/data/xen-xm-list-4.0.1-four-instances.txt \
1219         test/data/xen-xm-list-long-4.0.1.txt \
1220         test/data/xen-xm-uptime-4.0.1.txt \
1221         test/py/ganeti-cli.test \
1222         test/py/gnt-cli.test \
1223         test/py/import-export_unittest-helper
1224
1225
1226 python_tests = \
1227         doc/examples/rapi_testutils.py \
1228         test/py/cfgupgrade_unittest.py \
1229         test/py/docs_unittest.py \
1230         test/py/ganeti.asyncnotifier_unittest.py \
1231         test/py/ganeti.backend_unittest-runasroot.py \
1232         test/py/ganeti.backend_unittest.py \
1233         test/py/ganeti.bootstrap_unittest.py \
1234         test/py/ganeti.cli_unittest.py \
1235         test/py/ganeti.client.gnt_cluster_unittest.py \
1236         test/py/ganeti.client.gnt_instance_unittest.py \
1237         test/py/ganeti.client.gnt_job_unittest.py \
1238         test/py/ganeti.cmdlib_unittest.py \
1239         test/py/ganeti.cmdlib.cluster_unittest.py \
1240         test/py/ganeti.cmdlib.instance_storage_unittest.py \
1241         test/py/ganeti.compat_unittest.py \
1242         test/py/ganeti.confd.client_unittest.py \
1243         test/py/ganeti.config_unittest.py \
1244         test/py/ganeti.constants_unittest.py \
1245         test/py/ganeti.daemon_unittest.py \
1246         test/py/ganeti.errors_unittest.py \
1247         test/py/ganeti.hooks_unittest.py \
1248         test/py/ganeti.ht_unittest.py \
1249         test/py/ganeti.http_unittest.py \
1250         test/py/ganeti.hypervisor.hv_chroot_unittest.py \
1251         test/py/ganeti.hypervisor.hv_fake_unittest.py \
1252         test/py/ganeti.hypervisor.hv_kvm_unittest.py \
1253         test/py/ganeti.hypervisor.hv_lxc_unittest.py \
1254         test/py/ganeti.hypervisor.hv_xen_unittest.py \
1255         test/py/ganeti.hypervisor_unittest.py \
1256         test/py/ganeti.impexpd_unittest.py \
1257         test/py/ganeti.jqueue_unittest.py \
1258         test/py/ganeti.jstore_unittest.py \
1259         test/py/ganeti.locking_unittest.py \
1260         test/py/ganeti.luxi_unittest.py \
1261         test/py/ganeti.masterd.iallocator_unittest.py \
1262         test/py/ganeti.masterd.instance_unittest.py \
1263         test/py/ganeti.mcpu_unittest.py \
1264         test/py/ganeti.netutils_unittest.py \
1265         test/py/ganeti.objects_unittest.py \
1266         test/py/ganeti.opcodes_unittest.py \
1267         test/py/ganeti.outils_unittest.py \
1268         test/py/ganeti.ovf_unittest.py \
1269         test/py/ganeti.qlang_unittest.py \
1270         test/py/ganeti.query_unittest.py \
1271         test/py/ganeti.rapi.baserlib_unittest.py \
1272         test/py/ganeti.rapi.client_unittest.py \
1273         test/py/ganeti.rapi.resources_unittest.py \
1274         test/py/ganeti.rapi.rlib2_unittest.py \
1275         test/py/ganeti.rapi.testutils_unittest.py \
1276         test/py/ganeti.rpc_unittest.py \
1277         test/py/ganeti.runtime_unittest.py \
1278         test/py/ganeti.serializer_unittest.py \
1279         test/py/ganeti.server.rapi_unittest.py \
1280         test/py/ganeti.ssconf_unittest.py \
1281         test/py/ganeti.ssh_unittest.py \
1282         test/py/ganeti.storage.bdev_unittest.py \
1283         test/py/ganeti.storage.container_unittest.py \
1284         test/py/ganeti.storage.drbd_unittest.py \
1285         test/py/ganeti.storage.filestorage_unittest.py \
1286         test/py/ganeti.tools.burnin_unittest.py \
1287         test/py/ganeti.tools.ensure_dirs_unittest.py \
1288         test/py/ganeti.tools.node_daemon_setup_unittest.py \
1289         test/py/ganeti.tools.prepare_node_join_unittest.py \
1290         test/py/ganeti.uidpool_unittest.py \
1291         test/py/ganeti.utils.algo_unittest.py \
1292         test/py/ganeti.utils.filelock_unittest.py \
1293         test/py/ganeti.utils.hash_unittest.py \
1294         test/py/ganeti.utils.io_unittest-runasroot.py \
1295         test/py/ganeti.utils.io_unittest.py \
1296         test/py/ganeti.utils.log_unittest.py \
1297         test/py/ganeti.utils.lvm_unittest.py \
1298         test/py/ganeti.utils.mlock_unittest.py \
1299         test/py/ganeti.utils.nodesetup_unittest.py \
1300         test/py/ganeti.utils.process_unittest.py \
1301         test/py/ganeti.utils.retry_unittest.py \
1302         test/py/ganeti.utils.storage_unittest.py \
1303         test/py/ganeti.utils.text_unittest.py \
1304         test/py/ganeti.utils.wrapper_unittest.py \
1305         test/py/ganeti.utils.x509_unittest.py \
1306         test/py/ganeti.utils_unittest.py \
1307         test/py/ganeti.vcluster_unittest.py \
1308         test/py/ganeti.workerpool_unittest.py \
1309         test/py/pycurl_reset_unittest.py \
1310         test/py/qa.qa_config_unittest.py \
1311         test/py/tempfile_fork_unittest.py
1312
1313 haskell_tests = test/hs/htest
1314
1315 dist_TESTS = \
1316         test/py/check-cert-expired_unittest.bash \
1317         test/py/daemon-util_unittest.bash \
1318         test/py/ganeti-cleaner_unittest.bash \
1319         test/py/import-export_unittest.bash \
1320         test/py/cli-test.bash \
1321         test/py/bash_completion.bash
1322
1323 if PY_UNIT
1324 dist_TESTS += $(python_tests)
1325 endif
1326
1327 nodist_TESTS =
1328 check_SCRIPTS =
1329
1330 if WANT_HSTESTS
1331 nodist_TESTS += $(haskell_tests)
1332 dist_TESTS += test/hs/offline-test.sh
1333 check_SCRIPTS += \
1334         test/hs/hpc-htools \
1335         test/hs/hpc-mon-collector \
1336         $(HS_BUILT_TEST_HELPERS)
1337 endif
1338
1339 TESTS = $(dist_TESTS) $(nodist_TESTS)
1340
1341 # Environment for all tests
1342 PLAIN_TESTS_ENVIRONMENT = \
1343         PYTHONPATH=. \
1344         TOP_SRCDIR=$(abs_top_srcdir) TOP_BUILDDIR=$(abs_top_builddir) \
1345         PYTHON=$(PYTHON) FAKEROOT=$(FAKEROOT_PATH) \
1346         $(RUN_IN_TEMPDIR)
1347
1348 # Environment for tests run by automake
1349 TESTS_ENVIRONMENT = \
1350         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/testrunner
1351
1352 all_python_code = \
1353         $(dist_sbin_SCRIPTS) \
1354         $(python_scripts) \
1355         $(pkglib_python_scripts) \
1356         $(nodist_pkglib_python_scripts) \
1357         $(nodist_tools_python_scripts) \
1358         $(pkgpython_PYTHON) \
1359         $(client_PYTHON) \
1360         $(cmdlib_PYTHON) \
1361         $(hypervisor_PYTHON) \
1362         $(storage_PYTHON) \
1363         $(rapi_PYTHON) \
1364         $(server_PYTHON) \
1365         $(pytools_PYTHON) \
1366         $(http_PYTHON) \
1367         $(confd_PYTHON) \
1368         $(masterd_PYTHON) \
1369         $(impexpd_PYTHON) \
1370         $(utils_PYTHON) \
1371         $(watcher_PYTHON) \
1372         $(noinst_PYTHON) \
1373         $(qa_scripts)
1374
1375 if PY_UNIT
1376 all_python_code += $(python_tests)
1377 endif
1378
1379 srclink_files = \
1380         man/footer.rst \
1381         test/py/check-cert-expired_unittest.bash \
1382         test/py/daemon-util_unittest.bash \
1383         test/py/ganeti-cleaner_unittest.bash \
1384         test/py/import-export_unittest.bash \
1385         test/py/cli-test.bash \
1386         test/py/bash_completion.bash \
1387         test/hs/offline-test.sh \
1388         test/hs/cli-tests-defs.sh \
1389         $(all_python_code) \
1390         $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS) \
1391         $(docinput)
1392
1393 check_python_code = \
1394         $(BUILD_BASH_COMPLETION) \
1395         $(CHECK_IMPORTS) \
1396         $(CHECK_HEADER) \
1397         $(DOCPP) \
1398         $(all_python_code)
1399
1400 lint_python_code = \
1401         ganeti \
1402         ganeti/http/server.py \
1403         $(dist_sbin_SCRIPTS) \
1404         $(python_scripts) \
1405         $(pkglib_python_scripts) \
1406         $(BUILD_BASH_COMPLETION) \
1407         $(CHECK_IMPORTS) \
1408         $(CHECK_HEADER) \
1409         $(DOCPP) \
1410         $(PYTHON_BOOTSTRAP)
1411
1412 standalone_python_modules = \
1413         lib/rapi/client.py \
1414         tools/ganeti-listrunner
1415
1416 pep8_python_code = \
1417         ganeti \
1418         ganeti/http/server.py \
1419         $(dist_sbin_SCRIPTS) \
1420         $(python_scripts) \
1421         $(pkglib_python_scripts) \
1422         $(BUILD_BASH_COMPLETION) \
1423         $(CHECK_HEADER) \
1424         $(DOCPP) \
1425         $(PYTHON_BOOTSTRAP) \
1426         qa
1427
1428 test/py/daemon-util_unittest.bash: daemons/daemon-util
1429
1430 test/py/ganeti-cleaner_unittest.bash: daemons/ganeti-cleaner
1431
1432 test/py/bash_completion.bash: doc/examples/bash_completion-debug
1433
1434 tools/kvm-ifup: tools/kvm-ifup.in $(REPLACE_VARS_SED)
1435         sed -f $(REPLACE_VARS_SED) < $< > $@
1436         chmod +x $@
1437
1438 tools/vif-ganeti: tools/vif-ganeti.in $(REPLACE_VARS_SED)
1439         sed -f $(REPLACE_VARS_SED) < $< > $@
1440         chmod +x $@
1441
1442 tools/net-common: tools/net-common.in $(REPLACE_VARS_SED)
1443         sed -f $(REPLACE_VARS_SED) < $< > $@
1444         chmod +x $@
1445
1446 tools/users-setup: tools/users-setup.in $(REPLACE_VARS_SED)
1447         sed -f $(REPLACE_VARS_SED) < $< > $@
1448         chmod +x $@
1449
1450 tools/vcluster-setup: tools/vcluster-setup.in $(REPLACE_VARS_SED)
1451         sed -f $(REPLACE_VARS_SED) < $< > $@
1452         chmod +x $@
1453
1454 daemons/%:: daemons/%.in $(REPLACE_VARS_SED)
1455         sed -f $(REPLACE_VARS_SED) < $< > $@
1456         chmod +x $@
1457
1458 doc/examples/%:: doc/examples/%.in $(REPLACE_VARS_SED)
1459         sed -f $(REPLACE_VARS_SED) < $< > $@
1460
1461 doc/examples/bash_completion: BC_ARGS = --compact
1462 doc/examples/bash_completion-debug: BC_ARGS =
1463
1464 doc/examples/bash_completion doc/examples/bash_completion-debug: \
1465         $(BUILD_BASH_COMPLETION) $(RUN_IN_TEMPDIR) \
1466         lib/cli.py $(gnt_scripts) $(client_PYTHON) tools/burnin \
1467         daemons/ganeti-cleaner \
1468         $(GENERATED_FILES) $(HS_GENERATED_FILES)
1469         PYTHONPATH=. $(RUN_IN_TEMPDIR) \
1470           $(CURDIR)/$(BUILD_BASH_COMPLETION) $(BC_ARGS) > $@
1471
1472 man/%.gen: man/%.rst lib/query.py lib/build/sphinx_ext.py \
1473         lib/build/shell_example_lexer.py \
1474         | $(RUN_IN_TEMPDIR) $(BUILT_PYTHON_SOURCES)
1475         @echo "Checking $< for hardcoded paths..."
1476         @if grep -nEf autotools/wrong-hardcoded-paths $<; then \
1477           echo "Man page $< has hardcoded paths (see above)!" 1>&2 ; \
1478           exit 1; \
1479         fi
1480         set -e ; \
1481         trap 'echo auto-removing $@; rm $@' EXIT; \
1482         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(DOCPP) < $< > $@ ;\
1483         $(CHECK_MAN_REFERENCES) $@; \
1484         trap - EXIT
1485
1486 man/%.7.in man/%.8.in man/%.1.in: man/%.gen man/footer.rst
1487         @test -n "$(PANDOC)" || \
1488           { echo 'pandoc' not found during configure; exit 1; }
1489         set -o pipefail -e; \
1490         trap 'echo auto-removing $@; rm $@' EXIT; \
1491         $(PANDOC) -s -f rst -t man $< man/footer.rst | \
1492           sed -e 's/\\@/@/g' > $@; \
1493         if test -n "$(MAN_HAS_WARNINGS)"; then $(CHECK_MAN_WARNINGS) $@; fi; \
1494         $(CHECK_MAN_DASHES) $@; \
1495         trap - EXIT
1496
1497 man/%.html.in: man/%.gen man/footer.rst
1498         @test -n "$(PANDOC)" || \
1499           { echo 'pandoc' not found during configure; exit 1; }
1500         set -o pipefail ; \
1501         $(PANDOC) --toc -s -f rst -t html $< man/footer.rst | \
1502           sed -e 's/\\@/@/g' > $@
1503
1504 man/%: man/%.in  $(REPLACE_VARS_SED)
1505         sed -f $(REPLACE_VARS_SED) < $< > $@
1506
1507 epydoc.conf: epydoc.conf.in $(REPLACE_VARS_SED)
1508         sed -f $(REPLACE_VARS_SED) < $< > $@
1509
1510 vcs-version:
1511         if test -d .git; then \
1512           git describe > $@; \
1513         elif test ! -f $@ ; then \
1514           echo "Cannot auto-generate $@ file"; exit 1; \
1515         fi
1516
1517 .PHONY: clean-vcs-version
1518 clean-vcs-version:
1519         rm -f vcs-version
1520
1521 .PHONY: regen-vcs-version
1522 regen-vcs-version:
1523         @set -e; \
1524         cd $(srcdir); \
1525         if test -d .git; then \
1526           T=`mktemp` ; trap 'rm -f $$T' EXIT; \
1527           git describe > $$T; \
1528           if ! cmp --quiet $$T vcs-version; then \
1529             mv $$T vcs-version; \
1530           fi; \
1531         fi
1532
1533 src/Ganeti/Version.hs: src/Ganeti/Version.hs.in \
1534         vcs-version $(built_base_sources)
1535         set -e; \
1536         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1537         sed -e "s/%ver%/$$VCSVER/" < $< > $@
1538
1539 src/Ganeti/Constants.hs: src/Ganeti/Constants.hs.in \
1540         lib/constants.py lib/_autoconf.py lib/luxi.py lib/errors.py \
1541         lib/jstore.py $(RUN_IN_TEMPDIR) \
1542         $(CONVERT_CONSTANTS) $(built_base_sources) \
1543         | lib/_vcsversion.py
1544         set -e; \
1545         { cat $< ; \
1546           PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CONVERT_CONSTANTS); \
1547         } > $@
1548
1549 src/Ganeti/Curl/Internal.hs: src/Ganeti/Curl/Internal.hsc | stamp-directories
1550         hsc2hs -o $@ $<
1551
1552 test/hs/Test/Ganeti/TestImports.hs: test/hs/Test/Ganeti/TestImports.hs.in \
1553         $(built_base_sources)
1554         set -e; \
1555         { cat $< ; \
1556           echo ; \
1557           for name in $(filter-out Ganeti.THH,$(subst /,.,$(patsubst %.hs,%,$(patsubst src/%,%,$(HS_LIB_SRCS))))) ; do \
1558             echo "import $$name ()" ; \
1559           done ; \
1560         } > $@
1561
1562 lib/_autoconf.py: Makefile | stamp-directories
1563         set -e; \
1564         { echo '# This file is automatically generated, do not edit!'; \
1565           echo '#'; \
1566           echo ''; \
1567           echo '"""Build-time configuration for Ganeti.'; \
1568           echo '';\
1569           echo 'This file is autogenerated by the build process.'; \
1570           echo 'For any changes you need to re-run ./configure (and'; \
1571           echo 'not edit by hand).'; \
1572           echo ''; \
1573           echo '"""'; \
1574           echo ''; \
1575           echo '# pylint: disable=C0301,C0324'; \
1576           echo '# because this is autogenerated, we do not want'; \
1577           echo '# style warnings' ; \
1578           echo ''; \
1579           echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
1580           echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
1581           echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
1582           echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
1583           echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
1584           echo "VERSION_FULL = '$(VERSION_FULL)'"; \
1585           echo "LOCALSTATEDIR = '$(localstatedir)'"; \
1586           echo "SYSCONFDIR = '$(sysconfdir)'"; \
1587           echo "SSH_CONFIG_DIR = '$(SSH_CONFIG_DIR)'"; \
1588           echo "SSH_LOGIN_USER = '$(SSH_LOGIN_USER)'"; \
1589           echo "SSH_CONSOLE_USER = '$(SSH_CONSOLE_USER)'"; \
1590           echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
1591           echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
1592           echo "ES_SEARCH_PATH = [$(ES_SEARCH_PATH)]"; \
1593           echo "XEN_BOOTLOADER = '$(XEN_BOOTLOADER)'"; \
1594           echo "XEN_CONFIG_DIR = '$(XEN_CONFIG_DIR)'"; \
1595           echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
1596           echo "XEN_INITRD = '$(XEN_INITRD)'"; \
1597           echo "KVM_KERNEL = '$(KVM_KERNEL)'"; \
1598           echo "SHARED_FILE_STORAGE_DIR = '$(SHARED_FILE_STORAGE_DIR)'"; \
1599           echo "ENABLE_SHARED_FILE_STORAGE = $(ENABLE_SHARED_FILE_STORAGE)"; \
1600           echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
1601           echo "KVM_PATH = '$(KVM_PATH)'"; \
1602           echo "IP_PATH = '$(IP_PATH)'"; \
1603           echo "SOCAT_PATH = '$(SOCAT)'"; \
1604           echo "SOCAT_USE_ESCAPE = $(SOCAT_USE_ESCAPE)"; \
1605           echo "SOCAT_USE_COMPRESS = $(SOCAT_USE_COMPRESS)"; \
1606           echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)"; \
1607           echo "TOOLSDIR = '$(toolsdir)'"; \
1608           echo "GNT_SCRIPTS = [$(foreach i,$(notdir $(gnt_scripts)),'$(i)',)]"; \
1609           echo "HTOOLS_PROGS = [$(foreach i,$(HS_HTOOLS_PROGS),'$(i)',)]"; \
1610           echo "PKGLIBDIR = '$(pkglibdir)'"; \
1611           echo "DRBD_BARRIERS = '$(DRBD_BARRIERS)'"; \
1612           echo "DRBD_NO_META_FLUSH = $(DRBD_NO_META_FLUSH)"; \
1613           echo "SYSLOG_USAGE = '$(SYSLOG_USAGE)'"; \
1614           echo "DAEMONS_GROUP = '$(DAEMONS_GROUP)'"; \
1615           echo "ADMIN_GROUP = '$(ADMIN_GROUP)'"; \
1616           echo "MASTERD_USER = '$(MASTERD_USER)'"; \
1617           echo "MASTERD_GROUP = '$(MASTERD_GROUP)'"; \
1618           echo "RAPI_USER = '$(RAPI_USER)'"; \
1619           echo "RAPI_GROUP = '$(RAPI_GROUP)'"; \
1620           echo "CONFD_USER = '$(CONFD_USER)'"; \
1621           echo "CONFD_GROUP = '$(CONFD_GROUP)'"; \
1622           echo "LUXID_USER = '$(LUXID_USER)'"; \
1623           echo "LUXID_GROUP = '$(LUXID_GROUP)'"; \
1624           echo "NODED_USER = '$(NODED_USER)'"; \
1625           echo "NODED_GROUP = '$(NODED_GROUP)'"; \
1626           echo "MOND_USER = '$(MOND_USER)'"; \
1627           echo "MOND_GROUP = '$(MOND_GROUP)'"; \
1628           echo "DISK_SEPARATOR = '$(DISK_SEPARATOR)'"; \
1629           echo "QEMUIMG_PATH = '$(QEMUIMG_PATH)'"; \
1630           echo "HTOOLS = True"; \
1631           echo "ENABLE_CONFD = $(ENABLE_CONFD)"; \
1632           echo "XEN_CMD = '$(XEN_CMD)'"; \
1633           echo "ENABLE_SPLIT_QUERY = $(ENABLE_SPLIT_QUERY)"; \
1634           echo "ENABLE_RESTRICTED_COMMANDS = $(ENABLE_RESTRICTED_COMMANDS)"; \
1635           echo "ENABLE_MOND = $(ENABLE_MOND)"; \
1636 ## Write dictionary with man page name as the key and the section number as the
1637 ## value
1638           echo "MAN_PAGES = {"; \
1639           for i in $(notdir $(man_MANS)); do \
1640             echo "$$i" | sed -re 's/^(.*)\.([0-9]+)$$/  "\1": \2,/g'; \
1641           done; \
1642           echo "}"; \
1643         } > $@
1644
1645 lib/_vcsversion.py: Makefile vcs-version | stamp-directories
1646         set -e; \
1647         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1648         { echo '# This file is automatically generated, do not edit!'; \
1649           echo '#'; \
1650           echo ''; \
1651           echo '"""Build-time VCS version number for Ganeti.'; \
1652           echo '';\
1653           echo 'This file is autogenerated by the build process.'; \
1654           echo 'For any changes you need to re-run ./configure (and'; \
1655           echo 'not edit by hand).'; \
1656           echo ''; \
1657           echo '"""'; \
1658           echo ''; \
1659           echo '# pylint: disable=C0301,C0324'; \
1660           echo '# because this is autogenerated, we do not want'; \
1661           echo '# style warnings' ; \
1662           echo ''; \
1663           echo "VCS_VERSION = '$$VCSVER'"; \
1664         } > $@
1665
1666 lib/_generated_rpc.py: lib/rpc_defs.py $(BUILD_RPC)
1667         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_RPC) lib/rpc_defs.py > $@
1668
1669 $(SHELL_ENV_INIT): Makefile stamp-directories
1670         set -e; \
1671         { echo '# Allow overriding for tests'; \
1672           echo 'readonly LOCALSTATEDIR=$${LOCALSTATEDIR:-$${GANETI_ROOTDIR:-}$(localstatedir)}'; \
1673           echo 'readonly SYSCONFDIR=$${SYSCONFDIR:-$${GANETI_ROOTDIR:-}$(sysconfdir)}'; \
1674           echo; \
1675           echo 'readonly PKGLIBDIR=$(pkglibdir)'; \
1676           echo 'readonly LOG_DIR="$$LOCALSTATEDIR/log/ganeti"'; \
1677           echo 'readonly RUN_DIR="$$LOCALSTATEDIR/run/ganeti"'; \
1678           echo 'readonly DATA_DIR="$$LOCALSTATEDIR/lib/ganeti"'; \
1679           echo 'readonly CONF_DIR="$$SYSCONFDIR/ganeti"'; \
1680         } > $@
1681
1682 ## Writes sed script to replace placeholders with build-time values. The
1683 ## additional quotes after the first @ sign are necessary to stop configure
1684 ## from replacing those values as well.
1685 $(REPLACE_VARS_SED): $(SHELL_ENV_INIT) Makefile stamp-directories
1686         set -e; \
1687         { echo 's#@''PREFIX@#$(prefix)#g'; \
1688           echo 's#@''SYSCONFDIR@#$(sysconfdir)#g'; \
1689           echo 's#@''LOCALSTATEDIR@#$(localstatedir)#g'; \
1690           echo 's#@''BINDIR@#$(bindir)#g'; \
1691           echo 's#@''SBINDIR@#$(sbindir)#g'; \
1692           echo 's#@''LIBDIR@#$(libdir)#g'; \
1693           echo 's#@''GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
1694           echo 's#@''CUSTOM_XEN_BOOTLOADER@#$(XEN_BOOTLOADER)#g'; \
1695           echo 's#@''CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
1696           echo 's#@''CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
1697           echo 's#@''CUSTOM_IALLOCATOR_SEARCH_PATH@#$(IALLOCATOR_SEARCH_PATH)#g'; \
1698           echo 's#@''CUSTOM_EXPORT_DIR@#$(EXPORT_DIR)#g'; \
1699           echo 's#@''RPL_SSH_INITD_SCRIPT@#$(SSH_INITD_SCRIPT)#g'; \
1700           echo 's#@''PKGLIBDIR@#$(pkglibdir)#g'; \
1701           echo 's#@''GNTMASTERUSER@#$(MASTERD_USER)#g'; \
1702           echo 's#@''GNTRAPIUSER@#$(RAPI_USER)#g'; \
1703           echo 's#@''GNTCONFDUSER@#$(CONFD_USER)#g'; \
1704           echo 's#@''GNTLUXIDUSER@#$(LUXID_USER)#g'; \
1705           echo 's#@''GNTNODEDUSER@#$(NODED_USER)#g'; \
1706           echo 's#@''GNTMONDUSER@#$(MOND_USER)#g'; \
1707           echo 's#@''GNTRAPIGROUP@#$(RAPI_GROUP)#g'; \
1708           echo 's#@''GNTADMINGROUP@#$(ADMIN_GROUP)#g'; \
1709           echo 's#@''GNTCONFDGROUP@#$(CONFD_GROUP)#g'; \
1710           echo 's#@''GNTLUXIDGROUP@#$(LUXID_GROUP)#g'; \
1711           echo 's#@''GNTMASTERDGROUP@#$(MASTERD_GROUP)#g'; \
1712           echo 's#@''GNTMONDGROUP@#$(MOND_GROUP)#g'; \
1713           echo 's#@''GNTDAEMONSGROUP@#$(DAEMONS_GROUP)#g'; \
1714           echo 's#@''CUSTOM_ENABLE_CONFD@#$(ENABLE_CONFD)#g'; \
1715           echo 's#@''CUSTOM_ENABLE_MOND@#$(ENABLE_MOND)#g'; \
1716           echo 's#@''MODULES@#$(strip $(lint_python_code))#g'; \
1717           echo 's#@''XEN_CONFIG_DIR@#$(XEN_CONFIG_DIR)#g'; \
1718           echo; \
1719           echo '/^@SHELL_ENV_INIT@$$/ {'; \
1720           echo '  r $(SHELL_ENV_INIT)'; \
1721           echo '  d'; \
1722           echo '}'; \
1723         } > $@
1724
1725 # Using deferred evaluation
1726 daemons/ganeti-%: MODULE = ganeti.server.$(patsubst ganeti-%,%,$(notdir $@))
1727 daemons/ganeti-watcher: MODULE = ganeti.watcher
1728 scripts/%: MODULE = ganeti.client.$(subst -,_,$(notdir $@))
1729 tools/burnin: MODULE = ganeti.tools.burnin
1730 tools/ensure-dirs: MODULE = ganeti.tools.ensure_dirs
1731 tools/node-daemon-setup: MODULE = ganeti.tools.node_daemon_setup
1732 tools/prepare-node-join: MODULE = ganeti.tools.prepare_node_join
1733 tools/node-cleanup: MODULE = ganeti.tools.node_cleanup
1734 $(HS_BUILT_TEST_HELPERS): TESTROLE = $(patsubst test/hs/%,%,$@)
1735
1736 $(PYTHON_BOOTSTRAP): Makefile | stamp-directories
1737         test -n "$(MODULE)" || { echo Missing module; exit 1; }
1738         set -e; \
1739         { echo '#!/usr/bin/python'; \
1740           echo '# This file is automatically generated, do not edit!'; \
1741           echo "# Edit $(MODULE) instead."; \
1742           echo; \
1743           echo '"""Bootstrap script for L{$(MODULE)}"""'; \
1744           echo; \
1745           echo '# pylint: disable=C0103'; \
1746           echo '# C0103: Invalid name'; \
1747           echo; \
1748           echo 'import sys'; \
1749           echo 'import $(MODULE) as main'; \
1750           echo; \
1751           echo '# Temporarily alias commands until bash completion'; \
1752           echo '# generator is changed'; \
1753           echo 'if hasattr(main, "commands"):'; \
1754           echo '  commands = main.commands # pylint: disable=E1101'; \
1755           echo 'if hasattr(main, "aliases"):'; \
1756           echo '  aliases = main.aliases # pylint: disable=E1101'; \
1757           echo; \
1758           echo 'if __name__ == "__main__":'; \
1759           echo '  sys.exit(main.Main())'; \
1760         } > $@
1761         chmod u+x $@
1762
1763 $(HS_BUILT_TEST_HELPERS): Makefile
1764         @test -n "$(TESTROLE)" || { echo Missing TESTROLE; exit 1; }
1765         set -e; \
1766         { echo '#!/bin/sh'; \
1767           echo '# This file is automatically generated, do not edit!'; \
1768           echo "# Edit Makefile.am instead."; \
1769           echo; \
1770           echo "HTOOLS=$(TESTROLE) exec ./test/hs/hpc-htools \"\$$@\""; \
1771         } > $@
1772         chmod u+x $@
1773
1774 stamp-directories: Makefile
1775         $(MAKE) $(AM_MAKEFLAGS) ganeti
1776         @mkdir_p@ $(DIRS) $(BUILDTIME_DIR_AUTOCREATE)
1777         touch $@
1778
1779 # We need to create symlinks because "make distcheck" will not install Python
1780 # files when building.
1781 stamp-srclinks: Makefile | stamp-directories
1782         set -e; \
1783         for i in $(srclink_files); do \
1784           if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
1785             $(LN_S) $(abs_top_srcdir)/$$i $$i; \
1786           fi; \
1787         done
1788         touch $@
1789
1790 .PHONY: ganeti
1791 ganeti:
1792         cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
1793
1794 .PHONY: check-dirs
1795 check-dirs: $(GENERATED_FILES)
1796         @set -e; \
1797         find . -type d \( -name . -o -name .git -prune -o -print \) | { \
1798           error=; \
1799           while read dir; do \
1800             case "$$dir" in \
1801               $(strip $(patsubst %,(./%) ;;,$(DIRCHECK_EXCLUDE) $(DIRS))) \
1802               *) error=1; echo "Directory $$dir not listed in Makefile" >&2 ;; \
1803             esac; \
1804           done; \
1805           for dir in $(DIRS); do \
1806             if ! test -d "$$dir"; then \
1807               echo "Directory $$dir listed in DIRS does not exist" >&2; \
1808               error=1; \
1809             fi \
1810           done; \
1811           test -z "$$error"; \
1812         }
1813
1814 .PHONY: check-local
1815 check-local: check-dirs $(GENERATED_FILES)
1816         $(CHECK_PYTHON_CODE) $(check_python_code)
1817         PYTHONPATH=. $(CHECK_HEADER) $(check_python_code)
1818         $(CHECK_VERSION) $(VERSION) $(top_srcdir)/NEWS
1819         RELEASE=$(PACKAGE_VERSION) $(CHECK_NEWS) < $(top_srcdir)/NEWS
1820         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CHECK_IMPORTS) . $(standalone_python_modules)
1821         error= ; \
1822         if [ "x`echo $(VERSION_SUFFIX)|grep 'alpha'`" == "x" ]; then \
1823           expver=$(VERSION_MAJOR).$(VERSION_MINOR); \
1824           if test "`head -n 1 $(top_srcdir)/README`" != "Ganeti $$expver"; then \
1825             echo "Incorrect version in README, expected $$expver" >&2; \
1826             error=1; \
1827           fi; \
1828           for file in doc/iallocator.rst doc/hooks.rst doc/virtual-cluster.rst \
1829               doc/security.rst; do \
1830             if test "`sed -ne '4 p' $(top_srcdir)/$$file`" != \
1831               "Documents Ganeti version $$expver"; then \
1832               echo "Incorrect version in $$file, expected $$expver" >&2; \
1833               error=1; \
1834             fi; \
1835           done; \
1836           if ! test -f $(top_srcdir)/doc/design-$$expver.rst; then \
1837             echo "File $(top_srcdir)/doc/design-$$expver.rst not found" >&2; \
1838             error=1; \
1839           fi; \
1840           if test "`sed -ne '5 p' $(top_srcdir)/doc/design-draft.rst`" != \
1841             ".. Last updated for Ganeti $$expver"; then \
1842             echo "doc/design-draft.rst was not updated for version $$expver" >&2; \
1843             error=1; \
1844           fi; \
1845         fi; \
1846         for file in configure.ac $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS); do \
1847           if test $$(wc --max-line-length < $(top_srcdir)/$$file) -gt 80; then \
1848             echo "Longest line in $$file is longer than 80 characters" >&2; \
1849             error=1; \
1850           fi; \
1851         done; \
1852         test -z "$$error"
1853
1854 .PHONY: hs-test-%
1855 hs-test-%: test/hs/htest | $(BUILT_PYTHON_SOURCES)
1856         @rm -f htest.tix
1857         test/hs/htest -t $*
1858
1859 .PHONY: hs-tests
1860 hs-tests: test/hs/htest | $(BUILT_PYTHON_SOURCES)
1861         @rm -f htest.tix
1862         ./test/hs/htest
1863
1864 .PHONY: hs-shell-%
1865 hs-shell-%: test/hs/hpc-htools test/hs/hpc-mon-collector \
1866             $(HS_BUILT_TEST_HELPERS)
1867         @rm -f hpc-htools.tix hpc-mon-collector.tix
1868         HBINARY="./test/hs/hpc-htools" \
1869         SHELLTESTARGS=$(SHELLTESTARGS) \
1870         ./test/hs/offline-test.sh $*
1871
1872 .PHONY: hs-shell
1873 hs-shell: test/hs/hpc-htools test/hs/hpc-mon-collector $(HS_BUILT_TEST_HELPERS)
1874         @rm -f hpc-htools.tix hpc-mon-collector.tix
1875         HBINARY="./test/hs/hpc-htools" \
1876         SHELLTESTARGS=$(SHELLTESTARGS) \
1877         ./test/hs/offline-test.sh
1878
1879 .PHONY: hs-check
1880 hs-check: hs-tests hs-shell
1881
1882 # E111: indentation is not a multiple of four
1883 # E121: continuation line indentation is not a multiple of four
1884 #       (since our indent level is not 4)
1885 # E125: continuation line does not distinguish itself from next logical line
1886 #       (since our indent level is not 4)
1887 # E127: continuation line over-indented for visual indent
1888 #       (since our indent level is not 4)
1889 # note: do NOT add E128 here; it's a valid style error in most cases!
1890 # I've seen real errors, but also some cases were we indent wrongly
1891 # due to line length; try to rework the cases where it is triggered,
1892 # instead of silencing it
1893 # E261: at least two spaces before inline comment
1894 # E501: line too long (80 characters)
1895 PEP8_IGNORE = E111,E121,E125,E127,E261,E501
1896
1897 # For excluding pep8 expects filenames only, not whole paths
1898 PEP8_EXCLUDE = $(subst $(space),$(comma),$(strip $(notdir $(BUILT_PYTHON_SOURCES))))
1899
1900 LINT_TARGETS = pylint pylint-qa
1901 if HAS_PEP8
1902 LINT_TARGETS += pep8
1903 endif
1904 if HAS_HLINT
1905 LINT_TARGETS += hlint
1906 endif
1907
1908 .PHONY: lint
1909 lint: $(LINT_TARGETS)
1910
1911 .PHONY: pylint
1912 pylint: $(GENERATED_FILES)
1913         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1914         $(PYLINT) $(LINT_OPTS) $(lint_python_code)
1915
1916 .PHONY: pylint-qa
1917 pylint-qa: $(GENERATED_FILES)
1918         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1919         cd $(top_srcdir)/qa && \
1920           PYTHONPATH=$(abs_top_srcdir) $(PYLINT) $(LINT_OPTS) \
1921           --rcfile  ../pylintrc $(patsubst qa/%.py,%,$(qa_scripts))
1922
1923 .PHONY: pep8
1924 pep8: $(GENERATED_FILES)
1925         @test -n "$(PEP8)" || { echo 'pep8' not found during configure; exit 1; }
1926         $(PEP8) --ignore='$(PEP8_IGNORE)' --exclude='$(PEP8_EXCLUDE)' \
1927           --repeat $(pep8_python_code)
1928
1929 # FIXME: remove ignore "Use void" when GHC 6.x is deprecated
1930 HLINT_EXCLUDES = src/Ganeti/THH.hs test/hs/hpc-htools.hs
1931 .PHONY: hlint
1932 hlint: $(HS_BUILT_SRCS) src/lint-hints.hs
1933         @test -n "$(HLINT)" || { echo 'hlint' not found during configure; exit 1; }
1934         @rm -f doc/hs-lint.html
1935         if tty -s; then C="-c"; else C=""; fi; \
1936         $(HLINT) --utf8 --report=doc/hs-lint.html --cross $$C \
1937           --ignore "Use first" \
1938           --ignore "Use &&&" \
1939           --ignore "Use void" \
1940           --ignore "Reduce duplication" \
1941           --hint src/lint-hints \
1942           $(filter-out $(HLINT_EXCLUDES),$(HS_LIBTEST_SRCS) $(HS_PROG_SRCS))
1943         @if [ ! -f doc/hs-lint.html ]; then \
1944           echo "All good" > doc/hs-lint.html; \
1945         fi
1946
1947 # a dist hook rule for updating the vcs-version file; this is
1948 # hardcoded due to where it needs to build the file...
1949 dist-hook:
1950         $(MAKE) $(AM_MAKEFLAGS) regen-vcs-version
1951         rm -f $(top_distdir)/vcs-version
1952         cp -p $(srcdir)/vcs-version $(top_distdir)
1953
1954 # a distcheck hook rule for catching revision control directories
1955 distcheck-hook:
1956         if find $(top_distdir) -name .svn -or -name .git | grep .; then \
1957           echo "Found revision control files in final archive." 1>&2; \
1958           exit 1; \
1959         fi
1960         if find $(top_distdir) -name '*.py[co]' | grep .; then \
1961           echo "Found Python byte code in final archive." 1>&2; \
1962           exit 1; \
1963         fi
1964         if find $(top_distdir) -name '*~' | grep .; then \
1965           echo "Found backup files in final archive." 1>&2; \
1966           exit 1; \
1967         fi
1968 # Empty files or directories should not be distributed. They can cause
1969 # unnecessary warnings for packagers. Directories used by automake during
1970 # distcheck must be excluded.
1971         if find $(top_distdir) -empty -and -not \( \
1972             -path $(top_distdir)/_build -or \
1973             -path $(top_distdir)/_inst \) | grep .; then \
1974           echo "Found empty files or directories in final archive." 1>&2; \
1975           exit 1; \
1976         fi
1977         if test -e $(top_distdir)/doc/man-html; then \
1978           echo "Found documentation including man pages in final archive" >&2; \
1979           exit 1; \
1980         fi
1981
1982 # Backwards compatible distcheck-release target
1983 distcheck-release: distcheck
1984
1985 distrebuildcheck: dist
1986         set -e; \
1987         builddir=$$(mktemp -d $(abs_srcdir)/distrebuildcheck.XXXXXXX); \
1988         trap "echo Removing $$builddir; cd $(abs_srcdir); rm -rf $$builddir" EXIT; \
1989         cd $$builddir; \
1990         tar xzf $(abs_srcdir)/$(distdir).tar.gz; \
1991         cd $(distdir); \
1992         ./configure; \
1993         $(MAKE) maintainer-clean; \
1994         cp $(abs_srcdir)/vcs-version .; \
1995         ./configure; \
1996         $(MAKE) $(AM_MAKEFLAGS)
1997
1998 dist-release: dist
1999         set -e; \
2000         for i in $(DIST_ARCHIVES); do \
2001           echo -n "Checking $$i ... "; \
2002           autotools/check-tar < $$i; \
2003           echo OK; \
2004         done
2005
2006 install-exec-local:
2007         @mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
2008           "$(DESTDIR)${localstatedir}/log/ganeti" \
2009           "$(DESTDIR)${localstatedir}/run/ganeti"
2010
2011 .PHONY: apidoc
2012 if WANT_HSAPIDOC
2013 apidoc: py-apidoc hs-apidoc
2014 else
2015 apidoc: py-apidoc
2016 endif
2017
2018 .PHONY: py-apidoc
2019 py-apidoc: epydoc.conf $(RUN_IN_TEMPDIR) $(GENERATED_FILES)
2020         env - PATH="$$PATH" PYTHONPATH="$$PYTHONPATH" \
2021         $(RUN_IN_TEMPDIR) epydoc -v \
2022           --conf $(CURDIR)/epydoc.conf \
2023           --output $(CURDIR)/$(APIDOC_PY_DIR)
2024
2025 .PHONY: hs-apidoc
2026 hs-apidoc: $(APIDOC_HS_DIR)/index.html
2027
2028 $(APIDOC_HS_DIR)/index.html: $(HS_LIBTESTBUILT_SRCS) Makefile
2029         @test -n "$(HSCOLOUR)" || \
2030             { echo 'HsColour' not found during configure; exit 1; }
2031         @test -n "$(HADDOCK)" || \
2032             { echo 'haddock' not found during configure; exit 1; }
2033         rm -rf $(APIDOC_HS_DIR)/*
2034         for i in $(ALL_APIDOC_HS_DIRS); do \
2035           @mkdir_p@ $$i; \
2036           $(HSCOLOUR) -print-css > $$i/hscolour.css; \
2037         done
2038         set -e ; \
2039         export LC_ALL=en_US.UTF-8; \
2040         OPTGHC="--optghc=-isrc --optghc=-itest/hs"; \
2041         if [ "$(HS_PARALLEL3)" ]; \
2042         then OPTGHC="$$OPTGHC --optghc=$(HS_PARALLEL3)"; \
2043         fi; \
2044         if [ "$(HS_REGEX_PCRE)" ]; \
2045         then OPTGHC="$$OPTGHC --optghc=$(HS_REGEX_PCRE)"; \
2046         fi; \
2047         for file in $(HS_LIBTESTBUILT_SRCS); do \
2048           f_nosrc=$${file##src/}; \
2049           f_notst=$${f_nosrc##test/hs/}; \
2050           f_html=$${f_notst%%.hs}.html; \
2051           $(HSCOLOUR) -css -anchor $$file > $(APIDOC_HS_DIR)/$$f_html ; \
2052         done ; \
2053         $(HADDOCK) --odir $(APIDOC_HS_DIR) --html --ignore-all-exports -w \
2054           -t ganeti -p src/haddock-prologue \
2055           --source-module="%{MODULE/.//}.html" \
2056           --source-entity="%{MODULE/.//}.html#%{NAME}" \
2057           $$OPTGHC \
2058           $(HS_LIBTESTBUILT_SRCS)
2059
2060 .PHONY: TAGS
2061 TAGS: $(GENERATED_FILES)
2062         rm -f TAGS
2063         $(GHC) -e ":etags" -v0 \
2064           $(filter-out -O -Werror,$(HFLAGS)) \
2065           $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
2066           $(HS_LIBTEST_SRCS)
2067         find . -path './lib/*.py' -o -path './scripts/gnt-*' -o \
2068           -path './daemons/ganeti-*' -o -path './tools/*' -o \
2069           -path './qa/*.py' | \
2070           etags -l python -a -
2071
2072 .PHONY: coverage
2073
2074 COVERAGE_TESTS=
2075 if WANT_HTOOLS
2076 COVERAGE_TESTS += hs-coverage
2077 endif
2078 if PY_UNIT
2079 COVERAGE_TESTS += py-coverage
2080 endif
2081
2082 coverage: $(COVERAGE_TESTS)
2083
2084 .PHONY: py-coverage
2085 py-coverage: $(GENERATED_FILES) $(python_tests)
2086         @test -n "$(PYCOVERAGE)" || \
2087             { echo 'python-coverage' not found during configure; exit 1; }
2088         set -e; \
2089         COVERAGE=$(PYCOVERAGE) \
2090         COVERAGE_FILE=$(CURDIR)/$(COVERAGE_PY_DIR)/data \
2091         TEXT_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR)/report.txt \
2092         HTML_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR) \
2093         $(PLAIN_TESTS_ENVIRONMENT) \
2094         $(abs_top_srcdir)/autotools/gen-py-coverage \
2095         $(python_tests)
2096
2097 .PHONY: hs-coverage
2098 hs-coverage: $(haskell_tests) test/hs/hpc-htools test/hs/hpc-mon-collector
2099         rm -f *.tix
2100         $(MAKE) $(AM_MAKEFLAGS) hs-check
2101         @mkdir_p@ $(COVERAGE_HS_DIR)
2102         hpc sum --union $(HPCEXCL) \
2103           htest.tix hpc-htools.tix hpc-mon-collector.tix > coverage-hs.tix
2104         hpc markup --destdir=$(COVERAGE_HS_DIR) coverage-hs.tix
2105         hpc report coverage-hs.tix
2106         $(LN_S) -f hpc_index.html $(COVERAGE_HS_DIR)/index.html
2107
2108 # Special "kind-of-QA" target for htools, needs special setup (all
2109 # tools compiled with -fhpc)
2110 .PHONY: live-test
2111 live-test: all
2112         set -e ; \
2113         cd src; \
2114         rm -f .hpc; $(LN_S) ../.hpc .hpc; \
2115         rm -f *.tix *.mix; \
2116         ./live-test.sh; \
2117         hpc sum --union $(HPCEXCL) $(addsuffix .tix,$(HS_PROGS:src/%=%)) \
2118           --output=live-test.tix ; \
2119         @mkdir_p@ ../$(COVERAGE_HS_DIR) ; \
2120         hpc markup --destdir=../$(COVERAGE_HS_DIR) live-test \
2121           --srcdir=.. $(HPCEXCL) ; \
2122         hpc report --srcdir=.. live-test $(HPCEXCL)
2123
2124 commit-check: autotools-check distcheck lint apidoc
2125
2126 autotools-check:
2127         TESTDATA_DIR=./test/data shelltest $(SHELLTESTARGS) \
2128   $(abs_top_srcdir)/test/autotools/*-*.test \
2129   -- --hide-successes
2130
2131 .PHONY: gitignore-check
2132 gitignore-check:
2133         @if [ -n "`git status --short`" ]; then \
2134           echo "Git status is not clean!" 1>&2 ; \
2135           git status --short; \
2136           exit 1; \
2137         fi
2138
2139 # target to rebuild all man pages (both groff and html output)
2140 .PHONY: man
2141 man: $(man_MANS) $(manhtml)
2142
2143 # Target that builds all binaries (including those that are not
2144 # rebuilt except when running the tests)
2145 .PHONY: really-all
2146 really-all: all $(check_SCRIPTS) $(haskell_tests) $(HS_ALL_PROGS)
2147
2148 # we don't need the ancient implicit rules:
2149 %: %,v
2150 %: RCS/%,v
2151 %: RCS/%
2152 %: s.%
2153 %: SCCS/s.%
2154
2155 -include ./Makefile.local
2156
2157 # vim: set noet :